﻿/*
 * LdAuthRequest
 * 
 * initial implementation : 26.6.2013
 *
 * Copyright (c) Adam Sida, asida@centrum.cz.
 * All rights reserved.
 * 
 * for license see cz.uhul.DSMLv2.txt
 */
using System;
using System.Xml;
using System.Xml.Serialization;


namespace cz.uhul.DSMLv2
{





  /// <summary>
  /// The LdAuthRequest class indicates that access control for the requests be interpreted
  /// as though the requests are performed by the security principal identified by 
  /// the LdAuthRequest.Principal property.
  /// </summary>
  //[XmlType(TypeName = "authRequest")]
  //[XmlArrayItem("MemberName")]
  public class LdAuthRequest : LdRequest
  {




    public LdAuthRequest()
      :base()
    { }





    public LdAuthRequest(string principal)
      :this()
    {
      Principal = principal;
    }





    /// <summary>
    /// The LDAuthRequest.Principal property
    /// contains the security principal.
    /// </summary>
    [XmlAttribute(AttributeName = "principal")]
    public string Principal { get; set; }




  }

}