﻿/*
 * LdModifyDnRequest
 * 
 * initial implementation : 26.6.2013
 *
 * Copyright (c) Adam Sida, asida@centrum.cz.
 * All rights reserved.
 * 
 * for license see cz.uhul.DSMLv2.txt
 */
using System;
using System.Xml;
using System.Xml.Serialization;


namespace cz.uhul.DSMLv2
{




  /// <summary>
  /// The LDModifyDNRequest class modifies the distinguished name of an object.
  /// This class moves an object to a new parent and/or renames the object.
  /// </summary>
  [XmlType(TypeName = "modDNRequest")]
  //[XmlArrayItem("MemberName")]
  public class LdModifyDnRequest : LdDnRequest
  {




    public LdModifyDnRequest()
      :base()
    { }




    /// <summary>
    /// The LDModifyDNRequest.NewRDN property contains the new relative entry name.
    /// </summary>
    [XmlAttributeAttribute(AttributeName = "newrdn")]
    public string NewRDN { get; set; }





    /// <summary>
    /// The LDModifyDNRequest.DeleteOldRdn property specifies
    /// whether to delete the old relative distinguished name (RDN) of the entry. 
    /// </summary>
    [XmlAttributeAttribute(AttributeName = "deleteoldrdn")]
    public bool DeleteOldRDN { get; set; }





    /// <summary>
    /// LdModifyDNRequest.NewSuperior property contains the distinguished name
    /// of the new parent of the entry.
    /// </summary>
    [XmlAttributeAttribute(AttributeName = "newSuperior")]
    public string NewSuperior { get; set; }




  }

}