﻿/*
 * LdOperation
 * 
 * initial implementation : 26.6.2013
 *
 * Copyright (c) Adam Sida, asida@centrum.cz.
 * All rights reserved.
 * 
 * for license see cz.uhul.DSMLv2.txt
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Xml.Schema;
using System.Web;


namespace cz.uhul.DSMLv2
{


  /// <summary>
  /// Abstract base class for request and response operations in LdDocument, on LdConnection
  /// </summary>
  public abstract class LdOperation
  {


    public LdOperation()
    {
      Controls = new LdControlCollection();
    }



    /// <Summary>
    /// The LdOperation.Controls property contains a LdControlCollection object.
    /// </Summary>
    [XmlElement(ElementName = "control", Order = 2, Form = XmlSchemaForm.None, IsNullable = false)]
    public LdControlCollection Controls { get; set; }






    /// <Summary>
    /// The RequestId property contains the requestID specified in the request.
    /// </Summary>
    [XmlAttribute(AttributeName = "requestID", Form = XmlSchemaForm.None)]
    public string RequestId { get; set; }


  }

}