﻿/*
 * LdResultCodeEnum
 * 
 * initial implementation : 26.6.2013
 *
 * Copyright (c) Adam Sida, asida@centrum.cz.
 * All rights reserved.
 * 
 * for license see cz.uhul.DSMLv2.txt
 */
using System;
using System.Xml.Serialization;


namespace cz.uhul.DSMLv2
{

  /// <summary>
  /// The LdResultCodeEnum enumeration specifies the operation result codes.
  /// </summary>
  public enum LdResultCodeEnum
  {
    [XmlEnum ("11")]
    AdminLimitExceeded = 11,

    [XmlEnum("6")]
    AffectsMultipleDsas = 0x47,

    [XmlEnum("0x24")]
    AliasDereferencingProblem = 0x24,

    [XmlEnum("0x21")]
    AliasProblem = 0x21,

    [XmlEnum("20")]
    AttributeOrValueExists = 20,

    [XmlEnum("7")]
    AuthMethodNotSupported = 7,

    [XmlEnum("0x33")]
    Busy = 0x33,

    [XmlEnum("5")]
    CompareFalse = 5,

    [XmlEnum("6")]
    CompareTrue = 6,

    [XmlEnum("13")]
    ConfidentialityRequired = 13,

    [XmlEnum("0x13")]
    ConstraintViolation = 0x13,

    [XmlEnum("0x44")]
    EntryAlreadyExists = 0x44,

    [XmlEnum("0x30")]
    InappropriateAuthentication = 0x30,

    [XmlEnum("0x12")]
    InappropriateMatching = 0x12,

    [XmlEnum("50")]
    InsufficientAccessRights = 50,

    [XmlEnum("0x15")]
    InvalidAttributeSyntax = 0x15,

    [XmlEnum("0x22")]
    InvalidDNSyntax = 0x22,

    [XmlEnum("0x36")]
    LoopDetect = 0x36,

    [XmlEnum("0x40")]
    NamingViolation = 0x40,

    [XmlEnum("0x10")]
    NoSuchAttribute = 0x10,

    [XmlEnum("0x20")]
    NoSuchObject = 0x20,

    [XmlEnum("0x42")]
    NotAllowedOnNonLeaf = 0x42,

    [XmlEnum("0x43")]
    NotAllowedOnRdn = 0x43,

    [XmlEnum("0x45")]
    ObjectClassModificationsProhibited = 0x45,

    [XmlEnum("0x41")]
    ObjectClassViolation = 0x41,

    [XmlEnum("0x3d")]
    OffsetRangeError = 0x3d,

    [XmlEnum("1")]
    OperationsError = 1,

    [XmlEnum("80")]
    Other = 80,

    [XmlEnum("2")]
    ProtocolError = 2,

    [XmlEnum("10")]
    Referral = 10,

    [XmlEnum("9")]
    ReferralV2 = 9,

    [XmlEnum("70")]
    ResultsTooLarge = 70,

    [XmlEnum("14")]
    SaslBindInProgress = 14,

    [XmlEnum("4")]
    SizeLimitExceeded = 4,

    [XmlEnum("60")]
    SortControlMissing = 60,

    [XmlEnum("8")]
    StrongAuthRequired = 8,

    [XmlEnum("0")]
    Success = 0,

    [XmlEnum("3")]
    TimeLimitExceeded = 3,

    [XmlEnum("0x34")]
    Unavailable = 0x34,

    [XmlEnum("12")]
    UnavailableCriticalExtension = 12,

    [XmlEnum("0x11")]
    UndefinedAttributeType = 0x11,

    [XmlEnum("0x35")]
    UnwillingToPerform = 0x35,

    [XmlEnum("0x4c")]
    VirtualListViewError = 0x4c,
  }

}