﻿/*
 * LdSearchResponse
 * 
 * initial implementation : 26.6.2013
 *
 * Copyright (c) Adam Sida, asida@centrum.cz.
 * All rights reserved.
 * 
 * for license see cz.uhul.DSMLv2.txt
 */
using System;
using System.Collections.Generic;
using System.Web;
using System.Xml.Serialization;
using System.Xml.Schema;


namespace cz.uhul.DSMLv2
{




  /// <summary>
  /// The LdSearchResponse class is sent by the server as a response to a 
  /// LdSearchRequest object. This response contains zero or more LdSearchResultEntry objects
  /// , and zero or more LdSearchResultReference objects.
  /// </summary>
  [XmlType(TypeName = "searchResponse")]
  public class LdSearchResponse : LdResponse
  {




    public LdSearchResponse()
      :base()
    {
      SearchResultEntries = new LdSearchResultCollection();
    }






    public LdSearchResponse(LdResultCodeEnum code, string description, string errMsg)
      :base(code, description, errMsg)
    {
      SearchResultEntries = new LdSearchResultCollection();
    }





    /// <summary>
    /// The LdSearchResponse.Entries property contains a 
    /// LdSearchResultCollection object that contains the entries returned by the search.
    /// </summary>
    [XmlElement(ElementName = "searchResultEntry", Order = 1, Form = XmlSchemaForm.None, IsNullable = false, Type = typeof(LdEntry))]
    public LdSearchResultCollection SearchResultEntries { get; set; }


  }

}