
use LDDB



--init db
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_MAJOR', N'0', N'Major database version related to structure compatibility')
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_MINOR', N'2', N'minor version number when compatibility is not broken')
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_PROG', N'5', N'Version of program equipment')


INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'ROOT', N'LD root definitions', 1)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'OBJ_CLS', N'LD Object class definitions', 5)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'OBJ_INHERITS', N'LD class hierarchy definitions', 2)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'OBJ_ATTRS', N'LD Object attributes definition', 10)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'ENTRIES', N'LD Object instance storage - directory entries', 20)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'VALS_?????', N'LD Object attribute values storage (different tables for different data types)', 30)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'SETTINGS', N'LD base settings', 0)

--begin

--uhul a eagri
exec ld.sp_CreateRoot 'c=cz', N'Adres sprvy propojen na eAgri', null



--base def
exec ld.sp_CreateObjectClass 'c=cz', 'top', 'abstract', N'zkl. abstraktni tda informanho modelu', null
exec ld.sp_CreateObjectClass 'c=cz', 'group', 'abstract', N'zkl. tda definujc skupinu', null
exec ld.sp_CreateObjectClass 'c=cz', 'user', 'abstract', N'zkl. tda definujc uivatele', null
exec ld.sp_CreateObjectClass 'c=cz', 'unit', 'abstract', N'zkl. tda definujc jednotku', null

--uhul
exec ld.sp_CreateObjectClass 'c=cz', 'UzJednotka', 'abstract', N'zemn jednotka - specifick lenn zem', null
exec ld.sp_CreateObjectClass 'c=cz', 'PusobUzJednotka', 'abstract', N'zemn jednotka psobnosti organizace', null
exec ld.sp_CreateObjectClass 'c=cz', 'NutsPusobUzJednotka', 'structural', N'zemn jednotka psobnosti organizace rozlien pomoc NUTS', null
exec ld.sp_CreateObjectClass 'c=cz', 'LhcUzJednotka', 'structural', N'zemn jednotka lenn zem R na LHC', null
exec ld.sp_CreateObjectClass 'c=cz', 'HonitbaUzJednotka', 'structural', N'zemn jednotka lenn zem R na souvisl honebn pozemky', null
exec ld.sp_CreateObjectClass 'c=cz', 'OrpPusobUzJednotka', 'structural', N'zemn jednotka psobnosti organizace rozlien pomoc CISORP CSU', null
exec ld.sp_CreateObjectClass 'c=cz', 'OrgSkupina', 'structural', N'skupina definujc organizaci a jej leny', null
exec ld.sp_CreateObjectClass 'c=cz', 'AplikaceSkupina', 'structural', N'skupina definujc aplikaci a jej uivatele', null



--base inheritance
exec ld.sp_SetClassInheritance 'c=cz', 'top', null;
exec ld.sp_SetClassInheritance 'c=cz', 'group', 'top';
exec ld.sp_SetClassInheritance 'c=cz', 'user', 'top';
exec ld.sp_SetClassInheritance 'c=cz', 'unit', 'top';

--uhul
exec ld.sp_SetClassInheritance 'c=cz', 'UzJednotka', 'unit';
exec ld.sp_SetClassInheritance 'c=cz', 'LhcUzJednotka', 'UzJednotka';
exec ld.sp_SetClassInheritance 'c=cz', 'HonitbaUzJednotka', 'UzJednotka';

exec ld.sp_SetClassInheritance 'c=cz', 'PusobUzJednotka', 'UzJednotka';
exec ld.sp_SetClassInheritance 'c=cz', 'NutsPusobUzJednotka', 'PusobUzJednotka';
exec ld.sp_SetClassInheritance 'c=cz', 'OrpPusobUzJednotka', 'PusobUzJednotka';

exec ld.sp_SetClassInheritance 'c=cz', 'OrgSkupina', 'group';
exec ld.sp_SetClassInheritance 'c=cz', 'AplikaceSkupina', 'group';

--property
exec ld.sp_CreateSysAttribute 'c=cz', 'top', 'objectClass', 1, 2147483647, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'Schema class names', 'nvarchar(500)', null
exec ld.sp_CreateStandardizedAttribute 'c=cz', 'top', N'cn', 1, 3, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'common name', 'nvarchar(500)', null
exec ld.sp_CreateStandardizedAttribute 'c=cz', 'group', 'member', 1, 2147483647, 'OID=1.3.6.1.4.1.1466.115.121.1.12', 'member DN''s', 'uuid', null
exec ld.sp_CreateStandardizedAttribute 'c=cz', 'user', N'uid', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'user id', 'nvarchar(500)', null
exec ld.sp_CreateStandardizedAttribute 'c=cz', 'user', N'description', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.15', 'user description', 'nvarchar(500)', null

exec ld.sp_CreateAttribute 'c=cz', 'unit', N'nzev', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.15', 'Schema class names', 'nvarchar(500)', null

--uhul
exec ld.sp_CreateAttribute 'c=cz', 'NutsPusobUzJednotka', N'kodnuts', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'NUTS kd zemn jednotky', 'nvarchar(500)', null
exec ld.sp_CreateAttribute 'c=cz', 'OrpPusobUzJednotka', N'cisorp', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'kd ORP zemn jednotky', 'nvarchar(500)', null
exec ld.sp_CreateAttribute 'c=cz', 'OrgSkupina', N'I', 1, 1, 'OID=1.3.6.1.4.1.1466.115.121.1.26', 'identifikan slo organizace dle S', 'nvarchar(500)', null


--entries
exec ld.sp_CreateEntry 'c=cz', 'OrgSkupina', N'ou=sttn sprva myslivosti,o=Kr Stedoesk kraj,cn=Kr,cn=org,c=cz', null
exec ld.sp_CreateEntry 'c=cz', 'OrgSkupina', N'ou=sttn sprva les,o=M Brands nad Labem-Star Boleslav,cn=ORP,cn=org,c=cz', null

exec ld.sp_CreateEntry 'c=cz', 'AplikaceSkupina', N'cn=DS_SSL,cn=uhul,cn=app,cn=ssl,dc=eagri,dc=cz', null
exec ld.sp_CreateEntry 'c=cz', 'AplikaceSkupina', N'cn=MysliWeb,cn=uhul,cn=app,cn=ssl,dc=eagri,dc=cz', null

exec ld.sp_CreateEntry 'c=cz', 'LhcUzJednotka', N'cn=214701,cn=2012,cn=lhc,cn=zemn jednotky,o=mze,c=cz', null
exec ld.sp_CreateEntry 'c=cz', 'HonitbaUzJednotka', N'cn=CZ2103110003,cn=mysl01,cn=zemn jednotky,o=mze,c=cz', null

exec ld.sp_CreateEntry 'c=cz', 'NutsPusobUzJednotka', N'cn=esk republika,cn=NUTS 1,cn=CZ NUTS,cn=sprvn lenn,o=s,c=cz', null
exec ld.sp_CreateEntry 'c=cz', 'NutsPusobUzJednotka', N'cn=Stedoesk kraj,cn=NUTS 3,cn=CZ NUTS,cn=sprvn lenn,o=s,c=cz', null
exec ld.sp_CreateEntry 'c=cz', 'OrpPusobUzJednotka', N'cn=Brands nad Labem-Star Boleslav,cn=orp,cn=sprvn lenn,o=s,c=cz', null



--property
exec ld.sp_AddAttrValue 'c=cz', N'cn=Brands nad Labem-Star Boleslav,cn=orp,cn=sprvn lenn,o=s,c=cz', 'cisorp', '2103'



--testovani
exec ld.sp_GetEntryDef 'c=cz','HonitbaUzJednotka'

exec ld.sp_GetEntryAttribs 'c=cz','NutsPusobUzJednotka', 1

exec ld.sp_GetAttrValues 'c=cz', N'cn=Brands nad Labem-Star Boleslav,cn=orp,cn=sprvn lenn,o=s,c=cz', 'cisorp';



/*
pracovni....
*/

exec ld.sp_GetEntriesByDN RootDSE, DNlike;

exec ld.sp_GetEntriesBySchema RootDSE, SchemaDefName;

exec ld.sp_AddEditProperties RootDSE, DNlike, PropertyName, Value;
...



