use L2DB



--init db
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_MAJOR', N'0', N'Major database version related to structure compatibility')
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_MINOR', N'6', N'minor version number when compatibility is not broken')
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'DB_VERSION_PROG', N'8', N'Version of program equipment')
INSERT [dbo].[_NFO] ([PropertyCode], [PropertyValue], [Description]) VALUES (N'PURPOSE', N'el databze', N'Databze zjednoduen LDAP struktury upraven pro SQLServer. Databze slou pro zen pstup uivatel eagri aplikac na HL datov zdroje')


INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'ENTRIES', N'LD Object instance storage - directory entries', 20)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'REF_RELATIONS', N'LD reference relation storage table', 30)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'VAL_REL_DirectoryString', N'LD value relation storage table for DirectoryString types OID=1.3.6.1.4.1.1466.115.121.1.22', 30)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'VAL_REL_sname', N'LD value relation storage table for name and uid, OID=1.3.6.1.4.1.1466.115.121.1.36', 30)
INSERT [dbo].[LD_SCHEMA] ([ObjectName], [Description], [Order]) VALUES (N'VAL_REL_Uuid', N'LD value relation storage table for Uuid(windows GUID), OID=1.3.6.1.1.16.4', 30)



declare @RootKey uniqueidentifier
exec ld.sp_DeleteRoot 'ws-uhul', @RootKey OUT
print @RootKey

--begin
--schema
--

--uhul a eagri
exec ld.sp_AddRoot 'ID_UHUL', N'Adres sprvy propojen na eAgri', null


waitfor delay '00:00:00:300'
--declare system elements
exec ld.sp_AddEntry 'ID_UHUL', N'cn=group', 'top', 'group', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=group', 'mod', 'AUXILIARITY', null
waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', N'cn=person', 'top', 'person', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=person', 'mod', 'ABSTRACT', null
waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', N'cn=unit', 'top', 'unit', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=unit', 'mod', 'ABSTRACT', null
waitfor delay '00:00:00:300'

--declare attributes
exec ld.sp_AddEntry 'ID_UHUL', N'cn=member,cn=membership,cn=reference relations,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.15', 'member', 'cn=membership,cn=reference relations,cn=schema,cn=config', 1, null

--group can contain member
exec ld.sp_AddRelation 'ID_UHUL', N'cn=group', 'MAY', 'member', null


waitfor delay '00:00:00:300'
--definice vlastnich UHUL atributu
exec ld.sp_AddEntry 'ID_UHUL', N'cn=nzev,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.36', 'nzev', 'cn=schema,cn=config', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=nzev,cn=schema,cn=config', 'DESC', 'nzev jednotky, skupiny, aplikace, apod.', null

exec ld.sp_AddEntry 'ID_UHUL', N'cn=cisorp,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.36', 'cisorp', 'cn=schema,cn=config', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=cisorp,cn=schema,cn=config', 'DESC', 'kd ORP dle slovn S', null

exec ld.sp_AddEntry 'ID_UHUL', N'cn=CZ-NUTS,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.36', 'CZ-NUTS', 'cn=schema,cn=config', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=CZ-NUTS,cn=schema,cn=config', 'DESC', 'kd NUTS dle slovn S', null


waitfor delay '00:00:00:300'
--definice uhul trid
exec ld.sp_AddEntry 'ID_UHUL', 'cn=UzJednotka,cn=schema,cn=config', 'unit', 'UzJednotka', 'cn=schema,cn=config', 0 , null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=UzJednotka,cn=schema,cn=config', 'mod', 'ABSTRACT', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=UzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka - specifick lenn zem', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=UzJednotka,cn=schema,cn=config', 'MUST', 'nzev', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=PusobUzJednotka,cn=schema,cn=config', 'UzJednotka', 'PusobUzJednotka', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=PusobUzJednotka,cn=schema,cn=config', 'mod', 'ABSTRACT', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=UzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka psobnosti organizace', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=NutsPusobUzJednotka,cn=schema,cn=config', 'PusobUzJednotka', 'NutsPusobUzJednotka', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=NutsPusobUzJednotka,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=NutsPusobUzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka psobnosti organizace rozlien pomoc NUTS', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=NutsPusobUzJednotka,cn=schema,cn=config', 'MUST', 'CZ-NUTS', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=LhcUzJednotka,cn=schema,cn=config', 'UzJednotka', 'LhcUzJednotka', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=LhcUzJednotka,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=LhcUzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka lenn zem R na LHC', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=HonitbaUzJednotka,cn=schema,cn=config', 'UzJednotka', 'HonitbaUzJednotka', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=HonitbaUzJednotka,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=HonitbaUzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka lenn zem R na souvisl honebn pozemky', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=OrpPusobUzJednotka,cn=schema,cn=config', 'PusobUzJednotka', 'OrpPusobUzJednotka', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrpPusobUzJednotka,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrpPusobUzJednotka,cn=schema,cn=config', 'DESC', 'zemn jednotka psobnosti organizace rozlien pomoc CISORP CSU', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrpPusobUzJednotka,cn=schema,cn=config', 'MUST', 'cisorp', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=OrgSkupina,cn=schema,cn=config', 'unit', 'OrgSkupina', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrgSkupina,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrgSkupina,cn=schema,cn=config', 'objectClass', 'group', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrgSkupina,cn=schema,cn=config', 'DESC', 'skupina definujc organizaci a jej leny', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrgSkupina,cn=schema,cn=config', 'MAY', 'nzev', null

waitfor delay '00:00:00:300'
exec ld.sp_AddEntry 'ID_UHUL', 'cn=AplikaceSkupina,cn=schema,cn=config', 'unit', 'AplikaceSkupina', 'cn=schema,cn=config', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=AplikaceSkupina,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=AplikaceSkupina,cn=schema,cn=config', 'objectClass', 'group', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=AplikaceSkupina,cn=schema,cn=config', 'MAY', 'nzev', null

/*
pripravit tridu eagriUzivatel
STRUCTURAL
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=eagriUzivatel,cn=schema,cn=config', 'person', 'eagriUzivatel', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=eagriUzivatel,cn=schema,cn=config', 'mod', 'STRUCTURAL', null

/*
pripravit tridu eagriRole
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=eagriRole,cn=schema,cn=config', 'unit', 'eagriRole', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=eagriRole,cn=schema,cn=config', 'mod', 'STRUCTURAL', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=eagriRole,cn=schema,cn=config', 'objectClass', 'group', null

/*
pridani tridy data acl (bude mit atribut povolen pstup k LHC)
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'top', 'data acl', '', 0, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'mod', 'AUXILIARITY', null

/*
atribut povolen pstup k ... je odvozen od datoveho typu DN, pozor, mozna upravit na Uuid(OID=1.3.6.1.1.16.4)
pokud by byl odvozen z DN musel bych pro kazde LHC zakladat DN
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=povolen pstup k LHC,cn=membership,cn=reference relations,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.15', 'povolen pstup k LHC', 'cn=membership,cn=reference relations,cn=schema,cn=config', 1, null
exec ld.sp_AddEntry 'ID_UHUL', N'cn=povolen pstup k honitb,cn=membership,cn=reference relations,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.15', 'povolen pstup k honitb', 'cn=membership,cn=reference relations,cn=schema,cn=config', 1, null

exec ld.sp_AddEntry 'ID_UHUL', N'cn=datum povolen LHC,cn=membership,cn=reference relations,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.24', 'datum povolen LHC', 'cn=membership,cn=reference relations,cn=schema,cn=config', 1, null
exec ld.sp_AddEntry 'ID_UHUL', N'cn=datum povolen honitby,cn=membership,cn=reference relations,cn=schema,cn=config', '1.3.6.1.4.1.1466.115.121.1.24', 'datum povolen honitby', 'cn=membership,cn=reference relations,cn=schema,cn=config', 1, null


--data acl smi obsahovat atribut povolen pstup k LHC a 
exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'MAY', 'povolen pstup k LHC', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'MAY', 'povolen pstup k honitb', null

exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'MAY', 'datum povolen LHC', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'MAY', 'datum povolen honitby', null

exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'single-value', 'datum povolen LHC', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=data acl,cn=schema,cn=config', 'single-value', 'datum povolen honitby', null

--eagriUzivatel je odvozen i od data acl
exec ld.sp_AddRelation 'ID_UHUL', N'cn=eagriUzivatel,cn=schema,cn=config', 'objectClass', 'data acl', null

--zaroven OrgSkupina je odvozena od data acl
exec ld.sp_AddRelation 'ID_UHUL', N'cn=OrgSkupina,cn=schema,cn=config', 'objectClass', 'data acl', null

--todo: specialni skupiny pro uredniky VLS, SZIF, apod...

--testovaci uzivatel data acl
exec ld.sp_AddEntry 'ID_UHUL', N'cn=sidaa,cn=IS_UHUL,o=mze,c=cz', 'eagriUzivatel', 'sidaa', 'cn=IS_UHUL,o=mze,c=cz', 1, null


/*
sablony pro zalozeni ruznych typu entry v eagri
organizace:
1 kraj ssl
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=sttn sprva les,cn=Kr Stedoesk kraj,cn=Kr,cn=org,c=cz', 'OrgSkupina', 'sttn sprva les', 'cn=Kr Stedoesk kraj,cn=Kr,cn=org,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=sttn sprva les,cn=Kr Stedoesk kraj,cn=Kr,cn=org,c=cz', 'nzev', 'Krajsk ad stedoeskho kraje, odbor SSL', null

/*
1.ORP SSL
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=sttn sprva les,cn=M Brands nad Labem-Star Boleslav,cn=ORP,cn=org,c=cz', 'OrgSkupina', 'sttn sprva les', 'cn=M Brands nad Labem-Star Boleslav,cn=ORP,cn=org,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=sttn sprva les,cn=M Brands nad Labem-Star Boleslav,cn=ORP,cn=org,c=cz', 'nzev', 'Mstsk ad Brands nad Labem-Star Boleslav, odbor SSL', null


/*
2.sprvn uzemi

CR
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=esk republika,cn=CZ NUTS1,cn=sprvn lenn,o=s,c=cz', 'NutsPusobUzJednotka', 'esk republika', 'cn=CZ NUTS1,cn=sprvn lenn,o=s,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=esk republika,cn=CZ NUTS1,cn=sprvn lenn,o=s,c=cz', 'CZ-NUTS', 'CZ01', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=esk republika,cn=CZ NUTS1,cn=sprvn lenn,o=s,c=cz', 'nzev', 'Sprvn zem R', null

/*
NUTS3, kraje
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=Stedoesk kraj,cn=CZ NUTS3,cn=sprvn lenn,o=s,c=cz', 'NutsPusobUzJednotka', 'Stedoesk kraj', 'cn=CZ NUTS3,cn=sprvn lenn,o=s,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=Stedoesk kraj,cn=CZ NUTS3,cn=sprvn lenn,o=s,c=cz', 'CZ-NUTS', 'CZ020', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=Stedoesk kraj,cn=CZ NUTS3,cn=sprvn lenn,o=s,c=cz', 'nzev', 'zem v psobnosti stedoeskho kraje', null

/*
ORP
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=Brands nad Labem-Star Boleslav,cn=ORP,cn=sprvn lenn,o=s,c=cz', 'OrpPusobUzJednotka', 'Brands nad Labem-Star Boleslav', 'cn=ORP,cn=sprvn lenn,o=s,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=Brands nad Labem-Star Boleslav,cn=ORP,cn=sprvn lenn,o=s,c=cz', 'cisorp', '2103', null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=Brands nad Labem-Star Boleslav,cn=ORP,cn=sprvn lenn,o=s,c=cz', 'nzev', 'zem v psobnosti ORP Brands nad Labem-Star Boleslav', null


/*
aplikace
*/
exec ld.sp_AddEntry 'ID_UHUL', N'cn=DS SSL,cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 'AplikaceSkupina', 'DS SSL', 'cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=DS SSL,cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 'nzev', 'Aplikace pro ednky sttn sprvy les, prohlen zkonn evidence LHC', null

exec ld.sp_AddEntry 'ID_UHUL', N'cn=MysliWeb,cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 'AplikaceSkupina', 'MysliWeb', 'cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 1, null
exec ld.sp_AddRelation 'ID_UHUL', N'cn=MysliWeb,cn=uhul,cn=app,cn=ssl,cn=eagri,c=cz', 'nzev', 'Aplikace pro ednky sttn sprvy myslivosti, prohlen zkonn evidence MYSL01', null












